/**
 * Created by GoLand.
 * User: xzghua@gmail.com
 * Date: 2021/7/12
 * Time: 8:37 下午
 */
package main

import "fmt"

func main() {
	firstList := [][]int{{0, 2}, {5, 10}, {13, 23}, {24, 25}}
	secondList := [][]int{{1, 5}, {8, 12}, {15, 24}, {25, 26}}
	//firstList := [][]int{{10, 12}, {18, 19}}
	//secondList := [][]int{{1, 6}, {8, 11}, {13, 17}, {19, 20}}
	//fmt.Println(combine([]int{10, 12}, []int{9, 20}))
	s := intervalIntersection(firstList, secondList)
	for _, v := range s {
		fmt.Println(v)
	}
}

func intervalIntersection(firstList [][]int, secondList [][]int) [][]int {
	if len(firstList) == 0 || len(secondList) == 0 {
		return nil
	}

	var i, j int
	var re [][]int
	for len(firstList) > i && len(secondList) > j {
		res := combine(firstList[i], secondList[j])
		if res != nil {
			re = append(re, res)
		}

		if firstList[i][1] < secondList[j][1] {
			i++
		} else {
			j++
		}

	}

	return re
}

func combine(a, b []int) (r []int) {

	var minMax, maxMin int
	if a[0] > b[0] {
		minMax = a[0]
	} else {
		minMax = b[0]
	}

	if a[1] > b[1] {
		maxMin = b[1]
	} else {
		maxMin = a[1]
	}
	// 毫无相交
	if minMax > maxMin {
		return nil
	}

	return []int{minMax, maxMin}
}
